/*
   Test1-1.prg
   A sample dBL Program
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   Sample from: Chapter 23 
   This is an example of using structures, using the Structs.cc class
   that is also in this chapter, both by Jim Sare
*/

// Test1-1.PRG
set procedure to Structs.CC additive
if type("GetClientRect") # "FP"
   extern CLOGICAL GetClientRect(CHANDLE, CPTR) user32
endIf
xRECT = new StrRECT()             // Instantiate a RECT data structure
f = new Form()                    // Instantiate a form
f.left = 0                        // Move it out of the way
? f.hWND                          // Result: 0 (not a valid window)
f.open()                          // Make it a valid window
? f.hWND                          // Result: <> 0
GetClientRect(f.hWND, xRECT)      // Get client area size in pixels
? xRECT.left()                    // Result: 0
? xRECT.top()                     // Result: 0
? xRECT.right()                   // Result: > 0
? xRECT.bottom()                  // Result: > 0
nPPUX = xRECT.right() / f.Width   // Calculate pixels/horz form unit
nPPUY = xRECT.bottom() / f.Height // Calculate pixels/vert form unit
? nPPUX                           // Result:  7
? nPPUY                           // Result: 22
xRECT.logout(true)                // View structure contents
