** END HEADER -- do not remove this line
/*
   Data.cfm
   A sample dBL custom form from 
   The dBASE Book
   by Kenneth J. Mayer. 
   Program copyright 2005-2007. 
   Permission granted for use as a learning tool for dBASE Plus.

   The "Data" form used work with tables ...
*/
class DataCForm of BASECFORM custom from :MyCustomForms:Base.cfm
   with (this)
      onGotFocus = {; _app.CurrentForm = this}
      onLostFocus = {; _app.CurrentForm = null}
      open = class::FORM_OPEN
      readModal = class::FORM_READMODAL
   endwith

   this.TITLETEXT = new TEXT(this)
   with (this.TITLETEXT)
      height = 29.0
      left = 0.0
      top = 0.0
      width = 280.0
      anchor = 2	// Top
      colorNormal = "Navy/BtnFace"
      alignHorizontal = 1	// Center
      fontSize = 14.0
      text = "A Data Form"
      borderStyle = 1	// Raised
   endwith


   function form_open
      class::Init()
      return BASECFORM::open()

   function form_readModal
      class::Init()      
      return BASECFORM::readModal()

   function Init
      // do any startup code I want to occur before the form opens:

      // Check to see if the rowset property is not null
      if form.rowset # null 
         // if we have a rowset, go to first row:
         form.rowset.first()
      endif
      
   return

endclass

